#1 两数之和 Java

两数之和

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那两个整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum

方法1:首先想到的是暴力枚举
关键点在于两个for循环
外层for循环用来遍历前一个数,内层for循环用来枚举后一个数
判断 nums[i]+nums[j]==target

class Solution {
    public int[] twoSum(int[] nums, int target) {
    	int[] result=new int[2];//记录结果的数组
    	int i=0;
    	for(i=0;i<nums.length-1;i++){
      		for(int j=i+1;j<nums.length;j++){
                if(nums[i]+nums[j]==target){
                    result[0] = i;
                    result[1] = j;
                    return result;
                }
            }
        }
        return result;
    }
}	

时间复杂度:O(N2),其中 N 是数组中的元素数量。最坏情况下数组中任意两个数都要被匹配一次。
空间复杂度:O(1)。
方法2:使用哈希表
创建一个哈希表,对于每一个数 i,我们首先查询哈希表中是否存在 target - i,然后将 i 插入到哈希表中,即可保证不会让 i 和自己匹配。

import java.util.HashMap;
import java.util.Map;
class Solution {
    public int[] twoSum(int[] nums, int target) {
		int[] result = new int[2];//记录结果的数组
		HashMap<Integer,Integer> hash = new HashMap<Integer,Integer>();
		for(int i = 0;i < nums.length-1;i++){
			if(hash.contionsKey(nums[i])){
				result[0] = i;
				result[1] = hash.get(nums[i]);
			}
			hash.put(target-nums[i],i);
		}
		return result;
	}
}

时间复杂度:O(N),其中 N是数组中的元素数量。对于每一个元素 x,我们可以 O(1)地寻找 target - i。
空间复杂度:O(N),主要为哈希表的开销。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值